# Less4Clients

Less4Clients allows Express.js to render `.less` files when `?css` is appended to their urls.


## Example

- http://localhost:5000/asd.less
	
	``` less
	body {
		a {
			color:'bada55';
		}
	}
	```

- http://localhost:5000/asd.less?css

	``` css
	body a {
		color:'bada55';
	}
	```


## Installing


1. [Install Node.js](https://github.com/balupton/node/wiki/Installing-Node.js)

2. Install it

		npm install less4clients


## Using

- With Node.js in JavaScript

	``` javascript
	// Include Less4Clients
	require('coffee-script');
	less4clients = require('less4clients');

	// Setup with your Express Server
	less4clients.createInstance({
		server: null, // your express server (required)
		publicPath: '...', // the full path to your server root (required)
		missingAction: false, // the action to forward to when a file is not found
		cache: false, // whether the responses should be cached
		compress: false // whether the output should be compressed
	});
	```

- With Node.js in CoffeeScript
	
	``` coffeescript
	# Include Less4Clients
	less4clients = require 'less4clients'

	# Setup with your Express Server
	less4clients.createInstance {
		server: null # your express server (required)
		publicPath: '...' # the full path to your server root (required)
		missingAction: false # the action to forward to when a file is not found
		cache: false # whether the responses should be cached
		compress: false # whether the output should be compressed
	}


## History

- v0.1 July 5, 2011
	- Initial commit


## License

Licensed under the [MIT License](http://creativecommons.org/licenses/MIT/)
Copyright 2011 [Benjamin Arthur Lupton](http://balupton.com)
